import es
import nativetools as nt
from os import name

def touchCallback(index, touched):
    userid = nt.getUseridByIndex(index)
    if es.exists('userid', userid):
        if touched and index != touched:
            _touched = nt.getUseridByIndex(touched)
            if es.exists('userid', _touched):
                if es.getplayerteam(userid) == es.getplayerteam(_touched):
                    es.setplayerprop(userid, 'CBaseEntity.m_CollisionGroup', 2)
                else:
                    es.setplayerprop(userid, 'CBaseEntity.m_CollisionGroup', 5)
        else:
            es.setplayerprop(userid, 'CBaseEntity.m_CollisionGroup', 5)

class BNB(object):
    def __init__(self):
        self.players = {}
    def scriptLoad(self):
        es.ServerVar('bnb_ver', 1, "BackRaw's NoBlock - TeamOnly").makepublic()
        for x in es.getUseridList():
            self.registerUserid(x)
    def scriptUnload(self):
        self.unregisterUserid()
    def registerUserid(self, userid):
        userid = int(userid)
        self.players[userid] = int(es.createplayerlist(userid)[userid]['index'])
        nt.touchRegister(self.players[userid], touchCallback, True, 'player')
    def unregisterUserid(self, userid=False):
        if userid:
            userid = int(userid)
            if userid in self.players:
                nt.touchUnregister(self.players[userid], touchCallback)
                del self.players[userid]
        else:
            for userid in self.players:
                nt.touchUnregister(self.players[userid], touchCallback)
            self.players.clear()
bnb = BNB()

def load():
    if name == 'nt':
        bnb.scriptLoad()
    else:
        es.unload('bnb')

def unload():
    if name == 'nt':
        bnb.scriptUnload()

def player_activate(ev):
    bnb.registerUserid(ev['userid'])

def player_disconnect(ev):
    bnb.unregisterUserid(ev['userid'])